require 'spec_helper'
require 'random_array'

describe RandomArray do

  let(:random_array){ RandomArray.new }

  it 'should be descendant of MagicArray' do
    RandomArray.ancestors.should include(MagicArray)
  end

  context 'on init' do
    it 'should not contain elements' do
      random_array.count.should == 0
    end
  end

  it 'should generate element in range of its index when it is requested' do
    random_array[0].should < 1
    random_array[1].should == 0
    random_array[2].should < 2
    random_array[10].should < 10
  end

  it 'should generate array in requested range' do
    result_array = random_array[50..60]
    result_array.class.should be Array
    result_array.each_with_index do |element, index|
      element.should < 50+index
    end
  end

end